<template>
  <div class="w-100">
    <v-card
      variant="tonal"
      class="text-left text-justify px-2 my-3 card-width assistant-card d-inline-block"
      max-width="95%"
    >
      <v-card-text class="pa-0 ps-2 d-flex d-inline-block">
        <div class="flex-wrap align-center ps-2 py-2">
          <div v-highlight v-if="message.content" v-html="formattedContent"></div>
          <div v-else>Myślę</div>
        </div>
        <v-btn
          variant="text"
          elevation="0"
          class="pa-0 mt-1"
          style="min-width: 30px;"
          @click="handleClick"
          size="small"
        >
          <v-icon
            class="text-grey-darken-1 text-end"
            icon="fa-regular fa-copy"
          />
        </v-btn>
      </v-card-text>
    </v-card>
  </div>
</template>

<script>
import {defineComponent} from 'vue';
import showdown from 'showdown';

export default defineComponent({
  name: 'AssistantMessage',
  props: {
    message: Object,
  },
  methods: {
    handleClick: function () {
      let cleared = this.message.content.replace(/^```php/, '');
      let clearedSecond = cleared.replace(/```$/, '');
      navigator.clipboard.writeText(clearedSecond);
    },
  },
  computed: {
    formattedContent() {
      const converter = new showdown.Converter();
      return converter.makeHtml(this.message.content);
    },
  },
});
</script>

<style>

</style>

<style>
.assistant-card {
  border-radius: 8px 8px 8px 0;
}

pre {
  white-space: pre-wrap; /* Since CSS 2.1 */
  white-space: -moz-pre-wrap; /* Mozilla, since 1999 */
  white-space: -pre-wrap; /* Opera 4-6 */
  white-space: -o-pre-wrap; /* Opera 7 */
  word-wrap: break-word; /* Internet Explorer 5.5+ */
}
</style>

